local PlaceWealthButton = function(wealth_level, wealth_type)
  return PlaceObj
  (
    "XTemplateWindow", 
    {
      "__class",
      "XTextButton",
      "RolloverTemplate",
      "Rollover",
      "MouseCursor",
      "UI/Cursors/Rollover.tga",
      "FocusOrder",
      point(1000, 1),
      "RolloverText",
      T({
        990000000040,
        ""
      }),
      "RolloverTitle",
      T({
        990000000041,
        "财富水平"
      }),
      "RolloverHint",
      T({
        990000000042,
        "",
      }),
      "Id",
      "idWealthButton",
      "Dock",
      "right",
      "VAlign",
      "center",
      "OnPress",
      function(self, gamepad)
        local building = ResolvePropObj(self.context)
        
        if wealth_type == "wages" then building.wages_level = wealth_level end
        if wealth_type == "rents" then building.rents_level = wealth_level end
        if wealth_type == "prices" then building.prices_level = wealth_level end

        ObjModified(building)
      end,
      "OnContextUpdate",
      function(self, context)
        local building = ResolvePropObj(self.context)
        if building.wages_level == nil then building.wages_level = 0 end
        if building.rents_level == nil then building.rents_level = 0 end
        if building.prices_level == nil then building.prices_level = 0 end
        
        if wealth_type == "wages" and building.wages_level >= wealth_level then self:SetImage("UI/Infopanel/infopanel_workshift_active.tga") end
        if wealth_type == "wages" and building.wages_level < wealth_level then self:SetImage("UI/Infopanel/infopanel_workshift_stop.tga") end
        
        if wealth_type == "rents" and building.rents_level >= wealth_level then self:SetImage("UI/Infopanel/infopanel_workshift_active.tga") end
        if wealth_type == "rents" and building.rents_level < wealth_level then self:SetImage("UI/Infopanel/infopanel_workshift_stop.tga") end
        
        if wealth_type == "prices" and building.prices_level >= wealth_level then self:SetImage("UI/Infopanel/infopanel_workshift_active.tga") end
        if wealth_type == "prices" and building.prices_level < wealth_level then self:SetImage("UI/Infopanel/infopanel_workshift_stop.tga") end
        
        if wealth_type == "rents" and wealth_level == 0 then
          for i = #building.colonists, 1, -1 do
            local resident = building.colonists[i]
            if resident.workplace and resident.workplace.wages_level == nil then resident.workplace.wages_level = 0 end
            if (building.rents_level > 0 and not resident.workplace) 
            or (resident.workplace and resident.workplace.wages_level < building.rents_level) then
              resident:SetResidence(false)
              resident:UpdateResidence()
            end
          end
        end
      end,
      "Image",
      "UI/Infopanel/infopanel_workshift_time.tga",
      "Rows",
      2,
      "ColumnsUse",
      "abbbb"
    }
  )
end

function OnMsg.ClassesBuilt()
  XTemplates.customServiceWealth = PlaceObj("XTemplate", { PlaceObj
  (
    "XTemplateForEach", 
    {
      "array",
      function(parent, context)
        return nil, 1, 1
      end,
      "map",
      function(parent, context, array, i)
        return i
      end,
      "item_in_context",
      "Service"
    }, 
    {
      PlaceObj(
        "XTemplateTemplate", 
        {
          "__template",
          "InfopanelActiveSection",
          "Icon",
          "UI/Icons/Sections/Funding.tga",
          "Title",
          T({990000000043, "物价水平"}),
        }, 
        {
          PlaceWealthButton(4,"prices"),PlaceWealthButton(3,"prices"), PlaceWealthButton(2,"prices"), PlaceWealthButton(1,"prices"), PlaceWealthButton(0,"prices"),
        }
      )
    }
  )})
  
  XTemplates.customWorkplaceWealth = PlaceObj("XTemplate", { PlaceObj
  (
    "XTemplateForEach", 
    {
      "array",
      function(parent, context)
        return nil, 1, 1
      end,
      "map",
      function(parent, context, array, i)
        return i
      end,
      "item_in_context",
      "Workplace"
    }, 
    {
      PlaceObj(
        "XTemplateTemplate", 
        {
          "__template",
          "InfopanelActiveSection",
          "Icon",
          "UI/Icons/Sections/Funding.tga",
          "Title",
          T({990000000044, "薪资水平"}),
        }, 
        {
          PlaceWealthButton(4,"wages"), PlaceWealthButton(3,"wages"), PlaceWealthButton(2,"wages"), PlaceWealthButton(1,"wages"), PlaceWealthButton(0,"wages"),
        }
      )
    }
  )})
    
	XTemplates.customResidenceWealth = PlaceObj("XTemplate", { PlaceObj
  (
    "XTemplateForEach", 
    {
      "array",
      function(parent, context)
        return nil, 1, 1
      end,
      "map",
      function(parent, context, array, i)
        return i
      end,
      "item_in_context",
      "Residence"
    }, 
    {
      PlaceObj(
        "XTemplateTemplate", 
        {
          "__template",
          "InfopanelActiveSection",
          "Icon",
          "UI/Icons/Sections/Funding.tga",
          "Title",
          T({990000000045, "租金水平"}),
        }, 
        {
          PlaceWealthButton(4,"rents"), PlaceWealthButton(3,"rents"), PlaceWealthButton(2,"rents"), PlaceWealthButton(1,"rents"), PlaceWealthButton(0,"rents"),
        }
      )
    }
  )})
	
  XTemplates.sectionCustom = PlaceObj('XTemplate', { 
      group = "Infopanel Sections",
      id = "sectionCustom",
      XTemplates.sectionCustom,
      PlaceObj('XTemplateTemplate', {
          '__context_of_kind', "Service",
          '__template', "customServiceWealth",
      }),
      PlaceObj('XTemplateTemplate', {
          '__context_of_kind', "Residence",
          '__template', "customResidenceWealth",
      }),
      PlaceObj('XTemplateTemplate', {
          '__context_of_kind', "Workplace",
          '__template', "customWorkplaceWealth",
      }),
  })
end